ProjectedFeatureHolder (BioJava-1.5-beta API)
Keywords: org.biojava.bio.seq.projection.ProjectedFeatureHolder class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.seq.projection
Class ProjectedFeatureHolder

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.seq.AbstractFeatureHolder
              org.biojava.bio.seq.projection.ProjectedFeatureHolder

All Implemented Interfaces:
  Serializable, FeatureHolder, Changeable

    public final class ProjectedFeatureHolder

extends AbstractFeatureHolder
implements FeatureHolder, Serializable

Helper class for projecting Feature objects into an alternative coordinate system. This class offers a view onto a set of features, projecting them into a different coordinate system, and also changing their `parent` property. The destination coordinate system can run in the opposite direction from the source, in which case the `strand` property of StrandedFeatures is flipped.

The projected features returned by this class are small proxy objects. Proxy classes are autogenerated on demand for any sub-interface of `Feature` by the `ProjectionEngine` class.

Since:
  1.1
Author:
  Thomas Down, Matthew Pocock
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.seq.FeatureHolder
`FeatureHolder.EmptyFeatureHolder`

Field Summary

Fields inherited from interface org.biojava.bio.seq.FeatureHolder
`EMPTY_FEATURE_HOLDER, FEATURES, SCHEMA`

Constructor Summary
`ProjectedFeatureHolder(ProjectionContext context)`

Method Summary
`boolean` | `containsFeature(Feature f)` Check if the feature is present in this holder.
`int` | `countFeatures()` Count how many features are contained.
`Feature` | `createFeature(Feature.Template templ)` Create a new Feature, and add it to this FeatureHolder.
`Iterator` | `features()` Iterate over the features in no well defined order.
`FeatureHolder` | `filter(FeatureFilter ff)` Query this set of features using a supplied `FeatureFilter`.
`FeatureHolder` | `filter(FeatureFilter ff, boolean recurse)` Return a new FeatureHolder that contains all of the children of this one that passed the filter fc.
`protected ChangeEvent` | `forwardChangeEvent(ChangeEvent cev)` Called internally to generate a forwarded version of a ChangeEvent from our underlying FeatureHolder
`ProjectionContext` | `getContext()`
`FeatureFilter` | `getSchema()` Return a schema-filter for this `FeatureHolder`.
`protected FeatureHolder` | `makeProjectionSet(FeatureHolder fh)` Called internally to construct a lightweight projected view of a set of features
`void` | `removeFeature(Feature dyingChild)` Remove a feature from this FeatureHolder.

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, getChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Constructor Detail

### ProjectedFeatureHolder

    public ProjectedFeatureHolder(ProjectionContext context)

Method Detail

### getContext

    public ProjectionContext getContext()

### features

    public Iterator features()

  Description copied from interface: `FeatureHolder`
  Iterate over the features in no well defined order.

  Specified by:
    `features` in interface `FeatureHolder`
  Returns:
    an Iterator

### countFeatures

    public int countFeatures()

  Description copied from interface: `FeatureHolder`
  Count how many features are contained.

  Specified by:
    `countFeatures` in interface `FeatureHolder`
  Returns:
    a positive integer or zero, equal to the number of features contained

### containsFeature

    public boolean containsFeature(Feature f)

  Description copied from interface: `FeatureHolder`
  Check if the feature is present in this holder.

  Specified by:
    `containsFeature` in interface `FeatureHolder`
  Parameters:
    `f` - the Feature to check
  Returns:
    true if f is in this set

### filter

    public FeatureHolder filter(FeatureFilter ff)

  Description copied from interface: `FeatureHolder`
  Query this set of features using a supplied `FeatureFilter`.

  Specified by:
    `filter` in interface `FeatureHolder`
  Overrides:
    `filter` in class `AbstractFeatureHolder`
  Parameters:
    `ff` - the `FeatureFilter` to apply.
  Returns:
    all features in this container which match `filter`.

### filter

    public FeatureHolder filter(FeatureFilter ff,
                                boolean recurse)

  Description copied from interface: `FeatureHolder`
  Return a new FeatureHolder that contains all of the children of this one that passed the filter fc. This method is scheduled for deprecation. Use the 1-arg filter instead.

  Specified by:
    `filter` in interface `FeatureHolder`
  Overrides:
    `filter` in class `AbstractFeatureHolder`
  Parameters:
    `ff` - the FeatureFilter to apply
    `recurse` - true if all features-of-features should be scanned, and a single flat collection of features returned, or false if just immediate children should be filtered.

### createFeature

    public Feature createFeature(Feature.Template templ)
                          throws ChangeVetoException,
                                 BioException

  Description copied from interface: `FeatureHolder`
  Create a new Feature, and add it to this FeatureHolder. This method will generally only work on Sequences, and on some Features which have been attached to Sequences.

  Specified by:
    `createFeature` in interface `FeatureHolder`
  Overrides:
    `createFeature` in class `AbstractFeatureHolder`
  Throws:
    `ChangeVetoException` - if this FeatureHolder does not support creation of new features, or if the change was vetoed
    `BioException` - if something went wrong during creating the feature

### removeFeature

    public void removeFeature(Feature dyingChild)
                       throws ChangeVetoException,
                              BioException

  Description copied from interface: `FeatureHolder`
  Remove a feature from this FeatureHolder.

  Specified by:
    `removeFeature` in interface `FeatureHolder`
  Overrides:
    `removeFeature` in class `AbstractFeatureHolder`
  Throws:
    `ChangeVetoException` - if this FeatureHolder does not support feature removal or if the change was vetoed
    `BioException` - if there was an error removing the feature

### getSchema

    public FeatureFilter getSchema()

  Description copied from interface: `FeatureHolder`
  Return a schema-filter for this `FeatureHolder`. This is a filter which all `Feature`s immediately contained by this `FeatureHolder` will match. It need not directly match their child features, but it can (and should!) provide information about them using `FeatureFilter.OnlyChildren` filters. In cases where there is no feature hierarchy, this can be indicated by including `FeatureFilter.leaf` in the schema filter.

  For the truly non-informative case, it is possible to return `FeatureFilter.all`. However, it is almost always possible to provide slightly more information that this. For example, `Sequence` objects should, at a minimum, return `FeatureFilter.top_level`. `Feature` objects should, as a minimum, return `FeatureFilter.ByParent(new FeatureFilter.ByFeature(this))`.

  Specified by:
    `getSchema` in interface `FeatureHolder`
  Returns:
    the schema filter

### makeProjectionSet

    protected FeatureHolder makeProjectionSet(FeatureHolder fh)

  Called internally to construct a lightweight projected view of a set of features

### forwardChangeEvent

    protected ChangeEvent forwardChangeEvent(ChangeEvent cev)

  Called internally to generate a forwarded version of a ChangeEvent from our underlying FeatureHolder

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD